import { expect, tap } from '@push.rocks/tapbundle';

import * as smartgulp from '../ts/index.js';
import * as smartstream from '@push.rocks/smartstream';
import * as gulpFunction from 'gulp-function';
import * as smartpromise from '@push.rocks/smartpromise';

tap.test('smartgulp.src -> should read a directoy', async (tools) => {
  let done = smartpromise.defer();
  smartgulp
    .src(['./test/testfiles/**/*.md'])
    .pipe(
      gulpFunction.forEach(async (fileArg) => {
        console.log(fileArg.path);
      })
    )
    .pipe(
      gulpFunction.atEnd(async () => {
        done.resolve();
      })
    );
  await done.promise;
});

tap.test('smartgulp shoould replace files', async () => {
  let done = smartpromise.defer();
  smartgulp
    .src(['./test/testfiles/**/*.md'])
    .pipe(
      gulpFunction.forEach(async (fileArg) => {
        console.log(fileArg.path);
      })
    )
    .pipe(
      gulpFunction.atEnd(async () => {
        done.resolve();
      })
    )
    .pipe(smartgulp.replace());
  await done.promise;
});

await tap.start();
